from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.co2ToAirFuelCombustionBiophysical import CO2ToAirFuelCombustionBiophysical
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'co2ToAirFuelCombustion'


class Hierarchy_co2ToAirFuelCombustion(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = CO2ToAirFuelCombustionBiophysical()

        self.models = [model1]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_co2ToAirFuelCombustion()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_co2ToAirFuelCombustion(cycle)
