from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.co2ToAirLimeAndUreaIpcc2006 import CO2ToAirLimeAndUreaIpcc2006
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'co2ToAirUreaHydrolysis'


class Hierarchy_co2ToAirUreaHydrolysis(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = CO2ToAirLimeAndUreaIpcc2006()

        self.models = [model1]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_co2ToAirUreaHydrolysis()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_co2ToAirUreaHydrolysis(cycle)
