from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.n2OToAirFertilizerAndExcretaIndirectIpcc2006\
    import N2OToAirFertilizerAndExcretaIndirectIpcc2006
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'n2OToAirCropResidueDecompositionIndirect'


class Hierarchy_n2OToAirCropResidueDecompositionIndirect(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = N2OToAirFertilizerAndExcretaIndirectIpcc2006()

        self.models = [model1]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_n2OToAirCropResidueDecompositionIndirect()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_n2OToAirCropResidueDecompositionIndirect(cycle)
