from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.n2OToAirFertilizerAndExcretaDirectIpcc2006\
    import N2OToAirFertilizerAndExcretaDirectIpcc2006
from hestia_earth.calculation.models.n2OToAirFertilizerAndExcretadirectStehfestBouwman2006\
    import N2OToAirFertilizerAndExcretadirectStehfestBouwman2006
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'n2OToAirInorganicFertilizerDirect'


class Hierarchy_n2OToAirInorganicFertilizerDirect(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = N2OToAirFertilizerAndExcretadirectStehfestBouwman2006()
        model2 = N2OToAirFertilizerAndExcretaDirectIpcc2006()

        self.models = [model1, model2]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_n2OToAirInorganicFertilizerDirect()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_n2OToAirInorganicFertilizerDirect(cycle)
