from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.nh3ToAirCropResidueBurningAkagiEtAl2011AndIpcc2006\
    import NH3ToAirCropResidueBurningAkagiEtAl2011AndIpcc2006
from hestia_earth.calculation.models.ch4N2ONh3AndNoxToAirCropResidueBurningAkagiEtAl2011AndIpcc2006\
    import CH4N2ONH3AndNOXToAirCropResidueBurningAkagiEtAl2011AndIpcc2006
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'nh3ToAirCropResidueBurning'


class Hierarchy_nh3ToAirCropResidueBurning(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = NH3ToAirCropResidueBurningAkagiEtAl2011AndIpcc2006()
        model2 = CH4N2ONH3AndNOXToAirCropResidueBurningAkagiEtAl2011AndIpcc2006()

        self.models = [model1, model2]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_nh3ToAirCropResidueBurning()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_nh3ToAirCropResidueBurning(cycle)
