from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.noxToAirFertilizerAndExcretaStehfestBouwman2006\
    import NOXToAirFertilizerAndExcretaStehfestBouwman2006
from hestia_earth.calculation.models.noxToAirCropResidueBurningAkagiEtAl2011AndIpcc2006\
    import NOXToAirCropResidueBurningAkagiEtAl2011AndIpcc2006
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'noxToAirCropResidueDecomposition'


class Hierarchy_noxToAirCropResidueDecomposition(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = NOXToAirFertilizerAndExcretaStehfestBouwman2006()
        model2 = NOXToAirCropResidueBurningAkagiEtAl2011AndIpcc2006()

        self.models = [model1, model2]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_noxToAirCropResidueDecomposition()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_noxToAirCropResidueDecomposition(cycle)
