from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.noxToAirFertilizerAndExcretaStehfestBouwman2006 \
    import NOXToAirFertilizerAndExcretaStehfestBouwman2006
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'noxToAirInorganicFertilizer'


class Hierarchy_noxToAirInorganicFertilizer(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = NOXToAirFertilizerAndExcretaStehfestBouwman2006()

        self.models = [model1]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_noxToAirInorganicFertilizer()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_noxToAirInorganicFertilizer(cycle)
