from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.pToDrainageWaterSalcaPrasuhn2006 import PToDrainageWaterSalcaPrasuhn2006
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'pToDrainageWaterAllInputs'


class Hierarchy_pToDrainageWaterAllInputs(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = PToDrainageWaterSalcaPrasuhn2006()

        self.models = [model1]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_pToDrainageWaterAllInputs()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_pToDrainageWaterAllInputs(cycle)
