from hestia_earth.calculation.calculation_hierarchies import Emissions_hierarchy
from hestia_earth.calculation.models.pToGroundwaterSalcaPrasuhn2006 import PToGroundwaterSalcaPrasuhn2006
from hestia_earth.utils.api import download_hestia

MODEL_KEY = 'pToGroundwaterAllInputs'


class Hierarchy_pToGroundwaterAllInputs(Emissions_hierarchy):
    def __init__(self):
        super().__init__()
        self.term = download_hestia(MODEL_KEY)

        model1 = PToGroundwaterSalcaPrasuhn2006()

        self.models = [model1]

    def calculate_model(self, model, cycle):
        self.best_result = model.calculate_pToGroundwaterAllInputs()
        self.best_tier = model.tier

    def check_model(self, model, cycle):
        return model.check_pToGroundwaterAllInputs(cycle)
