from hestia_earth.calculation.abstract_model import Model
from hestia_earth.calculation.utils import average, summation

MODEL_KEY = 'freshwaterWithdrawals'


class FreshwaterWithdrawals(Model):
    def __init__(self):

        self.freshwaterWithdrawals = None

    def calculate(self):
        # Calculate water use
        emissionsResourceUse = {}
        self.freshwaterWithdrawals =\
            (self.irrigation/self.pyield) * (self.seed / (self.seed + self.pyield)) * self.econ/100

        emissionsResourceUse[MODEL_KEY] = self.freshwaterWithdrawals

        return emissionsResourceUse

    def check(self, cycle, product):
        # Calculate water use

        inputs = cycle['inputs'].evalues()
        self.irrigation = summation([sum(input['value'])
                                    if 'units' in input['term'] and input['term']['termType'] == 'water'
                                    else 0 for input in inputs])
        self.pyield = average(product['value'])
        self.seed = average(cycle['inputs']['seed']['value'])
        self.econ = product['economicValueShare']

        if self.irrigation != {} and self.pyield != {} and self.pyield > 0 and self.seed != {} and self.econ != {}:
            return True
        else:
            return False
