from hestia_earth.calculation.abstract_model import Model
from hestia_earth.calculation.utils import summation


class CO2ToAirFuelCombustionBiophysical(Model):
    def __init__(self):

        # Define model tier
        self.tier = 1

        # Define model requirements
        self.diesel = None

        # Instantiate variables
        self.co2ToAirFuelCombustion = None

        # Define model coeffients
        self.diesel_comb = 3.17     # TODO HLT

    def calculate_co2ToAirFuelCombustion(self):
        # Calculate total CO2 emissions

        self.co2ToAirFuelCombustion = self.diesel * (self.diesel_comb)

        return self.co2ToAirFuelCombustion

    def check_co2ToAirFuelCombustion(self, cycle):
        # Check that we have all the inputs

        diesel_ids = ['diesel', 'diesel1D', 'diesel2D', 'diesel4D', 'en590Diesel']

        filter_diesel = [sum(element['value']) for element in cycle['inputs'].evalues()
                         if element['term']['@id'] in diesel_ids]

        self.diesel = summation(filter_diesel)

        return self.diesel != {}
