from hestia_earth.calculation.abstract_model import Model


class NH3ToAirCropResidueDecompositionDeRuijterEtAl2010(Model):
    def __init__(self):

        # Define model tier
        self.tier = 1

        # Define model requirements
        self.aboveGroundCropResidueDryMatter = None
        self.nitrogenContent = None
        self.a = None

        # Instantiate variables
        self.nh3ToAirCropResidueDecomposition = None

    def calculate_nh3ToAirCropResidueDecomposition(self):
        # Calculate total nh3 emissions

        Nag = sum(self.aboveGroundCropResidueDryMatter) * self.nitrogenContent/100
        NH3_N = self.a * Nag

        self.nh3ToAirCropResidueDecomposition = NH3_N * 1.21589

        return self.nh3ToAirCropResidueDecomposition

    def check_nh3ToAirCropResidueDecomposition(self, cycle):
        # Check that we have all the inputs
        self.aboveGroundCropResidueDryMatter = cycle['products']['aboveGroundCropResidueDryMatter']['value']
        self.nitrogenContent = \
            cycle['products']['aboveGroundCropResidueDryMatter']['properties']['nitrogenContent']['value']

        self.a = (0.38 * 1000 / sum(self.aboveGroundCropResidueDryMatter) - 5.44) / 100 \
            if self.aboveGroundCropResidueDryMatter != {} and sum(self.aboveGroundCropResidueDryMatter) > 0 else None

        return self.aboveGroundCropResidueDryMatter != {} and self.nitrogenContent != {} and\
            self.a and 0 < self.a < 17
