import unittest
import json
from tests.utils import fixtures_path
from hestia_earth.calculation.abstract_engine import Engine
from hestia_earth.calculation.models.backgroundmodel import Backgroungmodel


class Test_backgroundmodel(unittest.TestCase):
    def __init__(self, *args, **kwargs):

        super(Test_backgroundmodel, self).__init__(*args, **kwargs)

        with open(f"{fixtures_path}/WI5hWtsqlu/Cycle/WI5hWtsqlu.jsonld") as jsonld_file:
            cycle = json.load(jsonld_file)

        with open(f"{fixtures_path}/WI5hWtsqlu/Site/2ppyB9xfAo.jsonld") as jsonld_file:
            site = json.load(jsonld_file)

        engine = Engine()
        engine.import_data(cycle, site)
        self.model = Backgroungmodel()
        self.representation = engine.data.safe_representation

    def test_check_backgroundmodel(self):

        check_computed = self.model.check(self.representation)

        self.assertEqual(check_computed, check_computed)

    def test_check_n2OToAirCropResidueBurningDirect(self):

        self.model.check(self.representation)
        computed = self.model.calculate_background("co2ToAirAllOrigins")
        self.assertEqual(computed, computed)


if __name__ == '__main__':
    unittest.main()
